Imports System.Data
Imports System.Data.OleDb

Public Class Form1
    ' Return a connect string for 
    ' the database in our code directory.
    Private Function MakeConnectString() As String
        ' Return the connect string 
        ' if we have already built it.
        Static connect_string As String = ""
        If connect_string.Length > 0 Then Return connect_string

        ' Make the database path.
        Dim db_path As String = Application.StartupPath
        db_path = db_path.Substring(0, db_path.LastIndexOf("\bin\"))

        ' Make the connect string.
        connect_string = _
            "Provider=Microsoft.Jet.OLEDB.4.0;" & _
            "Data Source=""" & db_path & "\CustomerAccounts.mdb"";" & _
            "Persist Security Info=False"

        Return connect_string
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles MyBase.Load
        ' Open the connection.
        Dim connAccounts As New OleDbConnection(MakeConnectString())
        connAccounts.Open()

        ' Display the current balances.
        ShowValues(connAccounts)

        ' Close the connection.
        connAccounts.Close()
    End Sub

    ' Display the account values.
    Private Sub ShowValues(ByVal conn As OleDbConnection)
        Dim txt As String = ""
        Dim select_cmd As New OleDbCommand( _
            "SELECT * FROM Accounts", _
            conn)
        Dim reader As OleDbDataReader = select_cmd.ExecuteReader()
        Do While reader.Read()
            txt &= _
                reader.Item("AccountName").ToString & ": " & _
                reader.Item("Balance").ToString & vbCrLf
        Loop

        txtValues.Text = txt
    End Sub

    Private Sub btnUpdate_Click(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnUpdate.Click
        ' Open the connection.
        Dim connAccounts As New OleDbConnection(MakeConnectString())
        connAccounts.Open()

        ' Make the transaction.
        Dim trans As OleDbTransaction = _
            connAccounts.BeginTransaction(IsolationLevel.ReadCommitted)

        ' Make a Command for this connection.
        ' and this transaction.
        Dim cmd As New OleDbCommand( _
            "UPDATE Accounts SET Balance=Balance + ? WHERE AccountName=?", _
            connAccounts, _
            trans)

        ' Create parameters for the first command.
        cmd.Parameters.Add(New OleDbParameter("Balance", _
            Decimal.Parse(txtAmount.Text)))
        cmd.Parameters.Add(New OleDbParameter("AccountName", _
            "Alice's Software Emporium"))

        ' Execute the second command.
        cmd.ExecuteNonQuery()

        ' Create parameters for the second command.
        cmd.Parameters.Clear()
        cmd.Parameters.Add(New OleDbParameter("Balance", _
            -Decimal.Parse(txtAmount.Text)))
        cmd.Parameters.Add(New OleDbParameter("AccountName", _
            "Bob's Consulting"))

        ' Execute the second command.
        cmd.ExecuteNonQuery()

        ' Commit the transaction.
        If MessageBox.Show( _
            "Commit transaction?", _
            "Commit?", _
            MessageBoxButtons.YesNo, _
            MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes _
        Then
            ' Commit the transaction.
            trans.Commit()
        Else
            ' Rollback the transaction.
            trans.Rollback()
        End If

        ' Display the current balances.
        ShowValues(connAccounts)

        ' Close the connection.
        connAccounts.Close()
    End Sub
End Class
