Imports System.Data
Imports System.Data.OleDb

Public Class Form1
    ' Return a connect string for 
    ' the database in our code directory.
    Private Function MakeConnectString() As String
        ' Return the connect string 
        ' if we have already built it.
        Static connect_string As String = ""
        If connect_string.Length > 0 Then Return connect_string

        ' Make the database path.
        Dim db_path As String = Application.StartupPath
        db_path = db_path.Substring(0, db_path.LastIndexOf("\bin\"))

        ' Make the connect string.
        connect_string = _
            "Provider=Microsoft.Jet.OLEDB.4.0;" & _
            "Data Source=""" & db_path & "\people.mdb"";" & _
            "Persist Security Info=False"

        Return connect_string
    End Function

    Private Sub btnAdd_Click(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnAdd.Click
        ' Open the connection.
        Dim conn_people As New OleDbConnection(MakeConnectString())
        conn_people.Open()

        ' Make a Command to insert data.
        Dim cmd As New OleDbCommand( _
            "INSERT INTO PeopleNames (FirstName, LastName) " & _
            "VALUES (?, ?)", _
            conn_people)

        ' Create parameters for the command.
        cmd.Parameters.Add(New OleDbParameter("FirstName", txtFirstName.Text))
        cmd.Parameters.Add(New OleDbParameter("LastName", txtLastName.Text))

        ' Execute the command.
        Try
            cmd.ExecuteNonQuery()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        ' Show the data.
        ShowValues(conn_people)

        ' Close the connection.
        conn_people.Close()
        conn_people.Dispose()
    End Sub

    Private Sub ShowValues(ByVal conn_people As OleDbConnection)
        Dim data_adapter As New OleDbDataAdapter( _
            "SELECT FirstName, LastName " & _
                "FROM PeopleNames " & _
                "ORDER BY FirstName, LastName", _
            conn_people)
        Dim data_table As New DataTable()
        data_adapter.Fill(data_table)
        Dim txt As String = ""
        For Each data_row As DataRow In data_table.Rows
            txt &= data_row.Item("FirstName").ToString & _
                " " & data_row.Item("LastName").ToString & vbCrLf
        Next data_row
        lblResults.Text = txt

        data_table.Dispose()
        data_adapter.Dispose()
    End Sub

    ' Display the initial data.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Open the connection.
        Dim conn_people As New OleDbConnection(MakeConnectString())
        conn_people.Open()

        ' Show the data.
        ShowValues(conn_people)

        conn_people.Close()
        conn_people.Dispose()
    End Sub
End Class
